'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _reactRelay = require('react-relay');

var _reactRelay2 = _interopRequireDefault(_reactRelay);

var _InterceptingNetworkLayer = require('./InterceptingNetworkLayer');

exports['default'] = function (_ref) {
    var Component = _ref.Component;
    var route = _ref.route;

    if (!(0, _InterceptingNetworkLayer.wasInjected)()) {
        throw new Error('NetworkLayer was not injected!');
    }
    return new Promise(function (resolve, reject) {
        var querySet = _reactRelay2['default'].getQueries(Component, route);

        _reactRelay2['default'].Store.forceFetch(querySet, function (_ref2) {
            var aborted = _ref2.aborted;
            var done = _ref2.done;
            var error = _ref2.error;
            var stale = _ref2.stale;

            if (error) {
                reject(error);
            } else if (aborted) {
                reject(new Error('Aborted'));
            } else if (done && !stale) {
                resolve(getQueryResults());
            }
        });

        function getQueryResults() {
            var results = {};

            Object.keys(querySet).forEach(function (name) {
                var result = _InterceptingNetworkLayer.queryResults.get(querySet[name]);
                if (!result) {
                    throw new Error('No result for query "' + name + '"');
                }
                results[name] = result;
            });
            return results;
        }
    });
};

module.exports = exports['default'];